-- name: [CS] Speedrunner Mario
-- description: YAHOOO!!!\n\nMade by: Samizzly \n\nOriginal by: TerminalMontage\n\n\\#DC1B31\\This Pack requires Character Select\nto use as a Library!

--[[
    API Documentation for Character Select can be found below:
    https://github.com/Squishy6094/character-select-coop/wiki/API-Documentation

    Use this if you're curious on how anything here works >v<
]]

-- Replace Mod Name with your Character/Pack name.
local TEXT_MOD_NAME = "Speedrunner Mario"

-- Stops mod from loading if Character Select isn't on, Does not need to be touched
if not _G.charSelectExists then
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
    return 0
end

--[[
    Everything from here down is character data, and is loaded at the end of the file

    Note that most things here are noted out via use of '--', if there is any
    functionality you'd want to use then remove the '--' in front of the functions.

    If needbe, Replace CHAR in the tables with your character's name
    Ex: E_MODEL_SPMARIO -> E_MODEL_SQUISHY

    Ensure all file naming is unique from other mods.
    Prefixing your files with your character's name should work fine
    Ex: life-icon.png -> squis
]]

local E_MODEL_SPMARIO =      smlua_model_util_get_id("yahoo_geo")      -- Located in "actors"
-- local E_MODEL_SPMARIO_STAR = smlua_model_util_get_id("yahoo_geo") -- Located in "actors"

local TEX_SPMARIO_LIFE_ICON = get_texture_info("yahoo-icon") -- Located in "textures"
local TEX_SPMARIO_STAR_ICON = get_texture_info("star-icon") -- Located in "textures"

-- All sound files are located in "sound" folder
-- Remember to include the file extention in the name
local VOICETABLE_SPMARIO = {
    [CHAR_SOUND_OKEY_DOKEY] =        'StartGame.ogg', -- Starting game
	[CHAR_SOUND_LETS_A_GO] =         'StartLevel.ogg', -- Starting level
	[CHAR_SOUND_PUNCH_YAH] =         'Punch1.ogg', -- Punch 1
	[CHAR_SOUND_PUNCH_WAH] =         'Punch2.ogg', -- Punch 2
	[CHAR_SOUND_PUNCH_HOO] =         'Punch3.ogg', -- Punch 3
	[CHAR_SOUND_YAH_WAH_HOO] =       {'Jump1.ogg', 'Jump2.ogg', 'Jump3.ogg'}, -- First Jump Sounds
	[CHAR_SOUND_HOOHOO] =            'DoubleJump.ogg', -- Second jump sound
	[CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'TripleJump1.ogg', 'TripleJump2.ogg'}, -- Triple jump sounds
	[CHAR_SOUND_UH] =                'Bonk.ogg', -- Wall bonk
	[CHAR_SOUND_UH2] =               'LongJumpLand.ogg', -- Landing after long jump
	[CHAR_SOUND_UH2_2] =             'LongJumpLand.ogg',
	[CHAR_SOUND_HAHA] =              'TripleJumpLand.ogg', -- Landing triple jump
	[CHAR_SOUND_YAHOO] =             'LongJump.ogg', -- Long jump
	[CHAR_SOUND_DOH] =               'Bonk.ogg', -- Long jump wall bonk
	[CHAR_SOUND_WHOA] =              'GrabLedge.ogg', -- Grabbing ledge
	[CHAR_SOUND_EEUH] =              'ClimbLedge.ogg', -- Climbing over ledge
	[CHAR_SOUND_WAAAOOOW] =          'Falling.ogg', -- Falling a long distance
	[CHAR_SOUND_TWIRL_BOUNCE] =      'FlowerBounce.ogg', -- Bouncing off of a flower spring
	[CHAR_SOUND_GROUND_POUND_WAH] =  'GroundPound.ogg', 
	[CHAR_SOUND_HRMM] =              'Lift.ogg', -- Lifting something
	[CHAR_SOUND_HERE_WE_GO] =        'GetStar.ogg', -- Star get
	[CHAR_SOUND_SO_LONGA_BOWSER] =   'SOLONGGAYBOWSER.ogg', -- Throwing Bowser
--DAMAGE
	[CHAR_SOUND_ATTACKED] = 'Damaged.ogg', -- Damaged
	[CHAR_SOUND_PANTING] = 'Panting.ogg', -- Low health
	[CHAR_SOUND_ON_FIRE] = 'MAMAAA.ogg', -- Burned
--SLEEP SOUNDS
	[CHAR_SOUND_IMA_TIRED] = 'Tired.ogg', -- Mario feeling tired
	[CHAR_SOUND_YAWNING] = 'Yawn.ogg', -- Mario yawning before he sits down to sleep
	[CHAR_SOUND_SNORING1] = 'Snore.ogg', -- Snore Inhale
	[CHAR_SOUND_SNORING2] = 'Exhale.ogg', -- Exhale
	[CHAR_SOUND_SNORING3] = 'SleepTalk.ogg', -- Sleep talking / mumbling
--COUGHING (USED IN THE GAS MAZE)
	[CHAR_SOUND_COUGHING1] = 'Cough1.ogg', -- Cough take 1
	[CHAR_SOUND_COUGHING2] = 'Cough2.ogg', -- Cough take 2
	[CHAR_SOUND_COUGHING3] = 'Cough3.ogg', -- Cough take 3
--DEATH
	[CHAR_SOUND_DYING] = 'Dying.ogg', -- Dying from damage
	[CHAR_SOUND_DROWNING] = 'Drowning.ogg', -- Running out of air underwater
	[CHAR_SOUND_MAMA_MIA] = 'LeaveLevel.ogg' -- Booted out of level
}

-- All Located in "actors" folder
-- (Models do not exist in template)

local CAPTABLE_SPMARIO = {
    normal = smlua_model_util_get_id("tmmnormalcap_geo"),
    wing = smlua_model_util_get_id("tmmwingcap_geo"),
    metal = smlua_model_util_get_id("tmmmetalcap_geo"),
}


local PALETTE_SPMARIO = {
    [PANTS]  = "254EAE",
    [SHIRT]  = "DC1B31",
    [GLOVES] = "E7E7E7",
    [SHOES]  = "000000",
    [HAIR]   = "4F3E38",
    [SKIN]   = "F5CDAB",
    [CAP]    = "DC1B31",
	[EMBLEM] = "000000"
}

-- All Located in "textures" folder

local HEALTH_METER_SPMARIO = {
    label = {
        left = get_texture_info("TMMhealthleft"),
        right = get_texture_info("TMMhealthright"),
    },
    pie = {
        [1] = get_texture_info("TMMhealth1"),
        [2] = get_texture_info("TMMhealth2"),
        [3] = get_texture_info("TMMhealth3"),
        [4] = get_texture_info("TMMhealth4"),
        [5] = get_texture_info("TMMhealth5"),
        [6] = get_texture_info("TMMhealth6"),
        [7] = get_texture_info("TMMhealth7"),
        [8] = get_texture_info("TMMhealth8"),
    }
}

--[[
    Everything from here down where the data is applied

    Note that nothing here other than the 'character_add' function
    is required for a custom character, if you don't have the assets
    then feel free to remove the function from the functions below
]]

local CSloaded = false

if _G.charSelectExists then
    -- Adds the custom character to the Character Select Menu
    CT_SPMARIO = _G.charSelect.character_add(
        "Speedrunner Mario", -- Character Name
        "YAHOOO!!!", -- Description
        "Mod by: Samizzly Original by: TerminalMontage", -- Credits
        "DC1B31",           -- Menu Color
        E_MODEL_SPMARIO,       -- Character Model
        CT_MARIO,           -- Override Character
        TEX_SPMARIO_LIFE_ICON, -- Life Icon
        1,                  -- Camera Scale
        0                   -- Vertical Offset
    )
end

local function on_character_select_load()
    -- Adds cap models to your character
    -- (Models do not exist in template)
    _G.charSelect.character_add_caps(E_MODEL_SPMARIO, CAPTABLE_SPMARIO)

    -- Adds a voice to your character
    -- (Sounds do not exist in template)
    _G.charSelect.character_add_voice(E_MODEL_SPMARIO, VOICETABLE_SPMARIO)

    -- Adds a celebration star to your character
    -- (Models do not exist in template)
    --_G.charSelect.character_add_celebration_star(E_MODEL_SPMARIO, E_MODEL_SPMARIO_STAR, TEX_SPMARIO_STAR_ICON)

    -- Adds a palette to your character
    _G.charSelect.character_add_palette_preset(E_MODEL_SPMARIO, PALETTE_SPMARIO)

    -- Adds a health meter to your character
    _G.charSelect.character_add_health_meter(CT_SPMARIO, HEALTH_METER_TMMARIO)

    -- Adds credits to the credits menu
    _G.charSelect.credit_add(TEXT_MOD_NAME, "Samizzly", "Creator of the CS mod")
    _G.charSelect.credit_add(TEXT_MOD_NAME, "Sunk", "BLJ Anywhere")
    _G.charSelect.credit_add(TEXT_MOD_NAME, "Brobgonal Second and JerThePear", "Tweaks")
    _G.charSelect.credit_add(TEXT_MOD_NAME, "Lucho Gamer and chrrli", "Special Thanks")

    CSloaded = true
end

-- Character Voice hooks
-- You will likely not need to care about these
-- Will soon be overhauled
local function on_character_sound(m, sound)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_SPMARIO then return _G.charSelect.voice.sound(m, sound) end
end

local function on_character_snore(m)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_SPMARIO then return _G.charSelect.voice.snore(m) end
end

hook_event(HOOK_ON_MODS_LOADED, on_character_select_load)
hook_event(HOOK_CHARACTER_SOUND, on_character_sound)
hook_event(HOOK_MARIO_UPDATE, on_character_snore)